#! /usr/bin/env mpscript 
 
""":"
exec python $0 ${1+"$@"}
"""
#

import Tkinter 
import Pmw
import fpformat
import string
 
class MpMotorView(Pmw.MegaWidget):
    def __init__(self, parent = None, **kw):
        # Define the megawidget options.
        optiondefs = (
	    ('motor',       None,            Pmw.INITOPT),
	    ('recordlist',  None,            Pmw.INITOPT),
	    ('orient',      'horizontal',    Pmw.INITOPT),
	    ('label',        None,            None),
	    ('title',       None,            None),
	    ('value',       0,               None),
            ('fg',          'blue',          None),
            ('format',      3,               None),
        )
        self.defineoptions(kw, optiondefs)
 
        # Initialise base class (after defining options).
        Pmw.MegaWidget.__init__(self, parent)
 
        # Create the components.
        interior = self.interior()
        
        # get the MX related stuff
        reclist = self['recordlist']
        self.motor = reclist.get_record(self['motor'])
        self.master = parent
        units = self.motor.get_field("units")
        self.format = self['format']
        label = self['label']
        if label is None:
             label = self.motor.get_field("label")
        if len(string.strip(label)) == 0:
             label = self['motor']
        # Create the motorname component.
        self.label = self.createcomponent('label',
                (), None,
                Tkinter.Label, interior, width = (len(label)+2),text = label)
 
        # Create the valueview component.
        self.lwt = 0.000
        self.view = self.createcomponent('view',
                (), None,
                Tkinter.Label, interior, width = self.format+5,text = self.lwt,fg=self['fg'])
 
        # Create the units component.
        self.units = self.createcomponent('units',
                (), None,
                Tkinter.Label, interior,
		    width = len(units), text = units)
 
 
	# Use grid to position all components
	if self['orient'] == 'vertical':
	    self.label.grid(row = 1, column = 1)
	    self.view.grid(row = 2, column = 1)
	    self.units.grid(row = 3, column = 1)
	    # Create the label.
#	    self.createlabel(interior, childRows=3)
	else:
	    self.label.grid(row = 1, column = 1)
	    self.view.grid(row = 1, column = 2)
	    self.units.grid(row = 1, column = 3)
	    # Create the label.
#	    self.createlabel(interior, childCols=3)

        # Check keywords and initialise options.
        self.initialiseoptions(MpMotorView)

        self.update_label()
 
    def update_label(self):
        position = self.motor.get_position()
        self.lwt = fpformat.fix(position,self.format)
        self.view.configure(text=self.lwt)
        self.master.update_idletasks()
        self.master.after(100,self.update_label)

Pmw.forwardmethods(MpMotorView, Tkinter.Label, 'view')
 
# Initialise Tkinter and Pmw.
def main(record_list, argv):
    root = Pmw.initialise()
    root.title('Pmw MpMotorView demonstration')

    # Create and pack two ThresholdScale megawidgets.
    mega3 = MpMotorView(root, orient = 'vertical', recordlist = record_list, motor = 'omega', label = 'OMEGA')
    mega3.pack(side = 'top', padx = 10, pady = 10)
    # Create and pack two ThresholdScale megawidgets.
    mega4 = MpMotorView(root, orient = 'horizontal', recordlist = record_list, motor = 'omega')
    mega4.pack(side = 'top', padx = 10, pady = 10)

    # Let's go.
    root.mainloop()
